package array;
/**
 * 题目：53. 最大子数组和 (maxSubArray)
 * 描述：给你一个整数数组 nums ，请你找出一个具有最大和的连续子数组（子数组最少包含一个元素），返回其最大和。
        子数组是数组中的一个连续部分。
 * 链接：https://leetcode.cn/problems/maximum-subarray/
 示例 1：
 输入：nums = [-2,1,-3,4,-1,2,1,-5,4]
 输出：6
 解释：连续子数组 [4,-1,2,1] 的和最大，为 6 。

 示例 2：
 输入：nums = [1]
 输出：1

 示例 3：
 输入：nums = [5,4,-1,7,8]
 输出：23

 */
//二刷会做
public class MaxSubArray {
    public int maxSubArray(int[] nums) {
        int tempsum=nums[0],maxsum=nums[0];
        for (int i = 1; i < nums.length; i++) {
            if(tempsum<0)
                tempsum=0;
            tempsum+=nums[i];
            if(maxsum<tempsum)
                maxsum=tempsum;
        }
        return maxsum;
    }
    //假设还要同时返回起始结束下标：
    //[-2,1,-3,4,-1,2,1,-5,4]
    public int[] maxSubArray2(int[] nums) {
        int tempsum = nums[0]; // 当前子数组的和
        int maxsum = nums[0];  // 最大子数组和
        int start = 0;         // 最大子数组的起始下标
        int end = 0;           // 最大子数组的结束下标
        int tempStart = 0;     // 当前子数组的起始下标

        for (int i = 1; i < nums.length; i++) {
            if (tempsum < 0) {
                tempsum = nums[i];  // 如果当前子数组和为负数，则重新从当前元素开始
                tempStart = i;      // 更新当前子数组的起始下标
            } else {
                tempsum += nums[i]; // 否则，继续扩展当前子数组
            }

            // 如果当前的子数组和大于之前的最大和，则更新最大和和区间的下标
            if (tempsum > maxsum) {
                maxsum = tempsum;
                start = tempStart;  // 记录最大子数组的起始下标
                end = i;            // 记录最大子数组的结束下标
            }
        }

        // 返回最大子数组的和以及起始和结束下标
        return new int[] {maxsum, start, end};
    }
}
