package array;
/**
 * 题目：189. 轮转数组 (rotate)
 * 描述：给定一个整数数组 nums，将数组中的元素向右轮转 k 个位置，其中 k 是非负数。

 * 链接：https://leetcode.cn/problems/rotate-array/
 示例 1:
 输入: nums = [1,2,3,4,5,6,7], k = 3
 输出: [5,6,7,1,2,3,4]
 解释:
 向右轮转 1 步: [7,1,2,3,4,5,6]
 向右轮转 2 步: [6,7,1,2,3,4,5]
 向右轮转 3 步: [5,6,7,1,2,3,4]

 示例 2:
 输入：nums = [-1,-100,3,99], k = 2
 输出：[3,99,-1,-100]
 解释:
 向右轮转 1 步: [99,-1,-100,3]
 向右轮转 2 步: [3,99,-1,-100]
 */
//二刷会做
public class RotateArray {
    public void rotateArray2(int[] nums, int k) {
        int cnt=nums.length,index=0;
        int offset=k%cnt;
        int[]temp=new int[k];
        for (int i = cnt-offset; i < cnt; i++) {
            temp[index]=nums[i];
            index++;
        }
        for (int i = cnt-1; i>=offset ; i--) {
            nums[i]=nums[i-offset];
        }
        for (int i = 0; i < offset; i++) {
            nums[i]=temp[i];
        }
    }

    public void rotateArray(int[] nums, int k) {
        int n = nums.length;
        k %= n;                  // 防止 k > n
        if (k == 0) return;

        // 1. 整体翻转 [0, n-1]
        reverse(nums, 0, n - 1);
        // 2. 前 k 个翻转 [0, k-1]
        reverse(nums, 0, k - 1);
        // 3. 剩余部分翻转 [k, n-1]
        reverse(nums, k, n - 1);
    }

    // 原地翻转 helper
    private void reverse(int[] a, int i, int j) {
        while (i < j) {
            int tmp = a[i];
            a[i++] = a[j];
            a[j--] = tmp;
        }
    }

}
