package backtrack;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * 题目： 491. 非递减子序列  (findSubsequences)
 * 描述：给你一个整数数组 nums ，找出并返回所有该数组中不同的递增子序列，递增子序列中 至少有两个元素 。你可以按 任意顺序 返回答案。
 * 数组中可能含有重复元素，如出现两个整数相等，也可以视作递增序列的一种特殊情况。

 示例 1：
 输入：nums = [4,6,7,7]
 输出：[[4,6],[4,6,7],[4,6,7,7],[4,7],[4,7,7],[6,7],[6,7,7],[7,7]]

 * 链接：https://leetcode.cn/problems/palindrome-partitioning/
 */
//不会做
public class FindSubsequences {
    /**
     * 用一个局部 Set<Integer> used 来去重，保证同一深度只选一次相同的数字。
     * 只有当当前路径为空或新加入的数字 ≥ 路径最后一个数字时，才继续深入。
     * 每次路径长度达到 ≥2 时，就收集一组结果。
     * @param nums
     * @return
     */
    public List<List<Integer>> findSubsequences(int[] nums) {
        List<List<Integer>> res = new ArrayList<>();
        backtrack(nums, 0, new ArrayList<>(), res);
        return res;
    }

    private void backtrack(int[] nums, int start, List<Integer> path, List<List<Integer>> res) {
        // 只要当前 path 长度 ≥2，就把它加入结果集
        if (path.size() >= 2) {
            res.add(new ArrayList<>(path));
        }
        // 用来在本层去重，防止同一层重复使用相同数字   这一步太妙了！！！
        Set<Integer> used = new HashSet<>();
        for (int i = start; i < nums.length; i++) {
            // 如果本层已经用过 nums[i]，跳过
            if (used.contains(nums[i])) continue;
            // 如果 path 为空或满足非递减条件，就可以选 nums[i]
            if (path.isEmpty() || nums[i] >= path.get(path.size() - 1)) {
                used.add(nums[i]);
                path.add(nums[i]);
                // 递归到下一层，从 i+1 开始选
                backtrack(nums, i + 1, path, res);
                // 撤销选择
                path.remove(path.size() - 1);
            }
        }
    }
}
