package slidingwindow;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;

/**
 * 题目：438.找到字符串中所有字母异位词 (findAnagrams)
 * 描述：给定两个字符串 s 和 p，找到 s 中所有 p 的 异位词 的子串，返回这些子串的起始索引。不考虑答案输出的顺序。
 * 链接：https://leetcode.cn/problems/find-all-anagrams-in-a-string/
 *
 示例 1:
 输入: s = "cbaebabacd", p = "abc"
 输出: [0,6]
 解释:
 起始索引等于 0 的子串是 "cba", 它是 "abc" 的异位词。
 起始索引等于 6 的子串是 "bac", 它是 "abc" 的异位词。

 示例 2:
 输入: s = "abab", p = "ab"
 输出: [0,1,2]
 解释:
 起始索引等于 0 的子串是 "ab", 它是 "ab" 的异位词。
 起始索引等于 1 的子串是 "ba", 它是 "ab" 的异位词。
 起始索引等于 2 的子串是 "ab", 它是 "ab" 的异位词。
 */

//没做出来
//二刷会做
public class FindAnagrams {
    public List<Integer> findAnagrams(String s, String p) {
        List<Integer> result = new ArrayList<>();
        if (s == null || p == null || s.length() < p.length()) {
            return result;
        }

        int[] pCount = new int[26];
        int[] sCount = new int[26];

        // 统计 p 中每个字符的频率
        for (char c : p.toCharArray()) {
            pCount[c - 'a']++;
        }

        int windowSize = p.length();
        // 初始化滑动窗口
        for (int i = 0; i < windowSize; i++) {
            sCount[s.charAt(i) - 'a']++;
        }

        // 比较初始窗口
        if (Arrays.equals(sCount,pCount)) {
            result.add(0);
        }

        // 滑动窗口
        for (int i = windowSize; i < s.length(); i++) {
            // 移除窗口左边的字符
            sCount[s.charAt(i - windowSize) - 'a']--;
            // 添加窗口右边的字符
            sCount[s.charAt(i) - 'a']++;

            // 比较当前窗口
            if (Arrays.equals(sCount,pCount)) {
                result.add(i - windowSize + 1);
            }
        }

        return result;
    }
}
